// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/Scene.hpp"
#include "game/DawnGame.hpp"
#include "prefabs/display/SimpleCubePrefab.hpp"

namespace Dawn {
  class PrefabTestingScene : public Scene {
    protected:
      SimpleCubePrefab *cube = nullptr;
      Camera *camera = nullptr;

    public:
      PrefabTestingScene(DawnGame *game) : Scene(game) {
        
      }

      std::vector<Asset*> getRequiredAssets() override {
        return std::vector<Asset*>();
      }

      void stage() override {
        camera = Camera::create(this);
        camera->transform->lookAt(glm::vec3(5, 5, 5), glm::vec3(0, 0, 0));
        cube = SimpleCubePrefab::create(this);
      }
  };
}